import 'package:flutter/cupertino.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:stage/stage.dart';

void main() {
  group('Stage', () {
    testWidgets('should render children', (tester) async {
      await tester.pumpWidget(Stage<int>(
        itemBuilder: (context, int layer) {
          return Text('$layer',
              textDirection: TextDirection.ltr, key: Key('$layer'));
        },
        stageBuilder: (constraints, selectItem) {
          final items = [
            selectItem(1),
            selectItem(2),
            selectItem(3),
          ];

          items.forEach((item) => item.layout(constraints));

          final data =
              items.map((item) => item.parentData as StageParentData).toList();

          data[0].offset = Offset(10, 10);
          data[1].offset = Offset(20, 20);
          data[2].offset = Offset(30, 30);

          return constraints.biggest;
        },
      ));

      expect(find.text('1'), findsOneWidget);
      expect(tester.getTopLeft(find.text('1')), Offset(10, 10));
      expect(find.text('2'), findsOneWidget);
      expect(tester.getTopLeft(find.text('2')), Offset(20, 20));
      expect(find.text('3'), findsOneWidget);
      expect(tester.getTopLeft(find.text('3')), Offset(30, 30));
    });
  });
}
